package cn.com.qmth.scancloud.tools.multithread;

import java.util.concurrent.locks.LockSupport;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public abstract class BatchConsumer<T>  extends Thread{
	private static final Logger LOG = LoggerFactory.getLogger(BatchConsumer.class);
	private Basket basket;
	
	public BatchConsumer() {
	}
	@SuppressWarnings("unchecked")
	@Override
	public void run() {
		try {
			for (;;) {
				//先判断是否有异常结束
				if(basket.isExcuteError()) {
					break;
				}
				//取消费数据
				Object o= basket.consume();
				//判断消费数据是否是结束
				if(o instanceof EndObject) {
					basket.countDown();
					break;
				}
				if(o instanceof ParkObject) {
					basket.countDown();
					LockSupport.park();
				}else {
					T t=(T)o;
					//消费数据实现
					consume(t);
				}
			}
		} catch (Exception e) {
			basket.setExcuteError(true);
			LOG.error("消费线程处理出错",e);
		} finally {
			basket.countDown();
		}
	}
	public abstract void consume(T t);
	protected Basket getBasket() {
		return basket;
	}
	protected void setBasket(Basket basket) {
		this.basket = basket;
	}
	
}
