package cn.com.qmth.scancloud.tools.multithread.consumer;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import cn.com.qmth.scancloud.tools.model.ExamStudent;
import cn.com.qmth.scancloud.tools.multithread.Consumer;
import cn.com.qmth.scancloud.tools.service.ExamStudentImportService;
import cn.com.qmth.scancloud.tools.service.impl.ExamStudentImportTask;

@Scope("prototype")
@Service
public class ExamStudentImportConsumer extends Consumer<List<ExamStudent>> {
    private static final Logger log = LoggerFactory.getLogger(ExamStudentImportTask.class);
    @Autowired
    private ExamStudentImportService ExamStudentImportService;
    
    @Override
    public int consume(List<ExamStudent> dto) {
        ExamStudentImportService.studentImport(dto);
        return dto.size();
    }

    @Override
    protected void processInfo() {
        log.info("已处理数：{} 进度：{} ", this.getBasket().getProcess().intValue(), this.getBasket().getProgress());
    }


}
